import { ElementRef, QueryList, Renderer, NgZone, IterableDiffers, DoCheck, AfterContentInit } from '@angular/core';
import { NgModel, ControlValueAccessor } from '@angular/forms';
import './igniteui';
export declare class Column {
    _settings: any;
    private _el;
    constructor(el: ElementRef);
    createColumnsSetter(name: any): (value: any) => void;
    createColumnsGetter(name: any): () => any;
}
export declare class Feature {
    private _el;
    _settings: any;
    initSettings: {};
    private name;
    constructor(el: ElementRef);
    ngOnInit(): void;
    createFeatureSetter(name: any): (value: any) => void;
    createFeatureGetter(name: any): () => any;
}
export declare function IgComponent(args?: any): (cls: any) => any;
export declare class IgControlBase<Model> implements DoCheck {
    private _differs;
    protected _opts: any;
    protected _el: any;
    protected _widgetName: string;
    protected _differ: any;
    protected _config: any;
    protected _events: Map<string, string>;
    protected _allowChangeDetection: boolean;
    options: Model;
    widgetId: string;
    changeDetectionInterval: number;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    createSetter(name: any): (value: any) => void;
    ngOnInit(): void;
    ngDoCheck(): void;
    optionChange(): void;
    isDate(value: any): boolean;
    isRegExp(value: any): boolean;
    isScope(obj: any): any;
    isWindow(obj: any): any;
    isFunction(value: any): boolean;
    isArray(value: any): boolean;
    equalsDiff(o1: any, o2: any, diff?: any): boolean;
    convertToCamelCase(str: any): any;
}
export declare class IgGridBase<Model> extends IgControlBase<Model> implements AfterContentInit {
    protected _dataSource: any;
    protected _changes: any;
    _columns: QueryList<Column>;
    _features: QueryList<Feature>;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    deleteRow(id: any): void;
    addRow(rowData: any, index: any): void;
    ngDoCheck(): void;
}
export declare class IgGridComponent extends IgGridBase<IgGrid> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgTreeGridComponent extends IgGridBase<IgTreeGrid> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    deleteRow(id: any): void;
    ngDoCheck(): void;
}
export declare class IgHierarchicalGridComponent extends IgGridBase<IgHierarchicalGrid> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    deleteRow(id: any): void;
    ngDoCheck(): void;
}
export declare class IgComboComponent extends IgControlBase<IgCombo> implements ControlValueAccessor {
    model: NgModel;
    protected _model: any;
    private _dataSource;
    private _changes;
    constructor(model: NgModel, el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    ngOnInit(): void;
    writeValue(value: any): void;
    onChange: (_: any) => void;
    onTouched: () => void;
    registerOnChange(fn: () => any): void;
    registerOnTouched(fn: () => any): void;
    ngDoCheck(): void;
}
export declare class IgEditorBase<Model> extends IgControlBase<Model> implements ControlValueAccessor {
    model: NgModel;
    protected _model: any;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
    ngOnInit(): void;
    writeValue(value: any): void;
    onChange: (_: any) => void;
    onTouched: () => void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
}
export declare class IgCheckboxEditorComponent extends IgEditorBase<IgCheckboxEditor> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
}
export declare class IgCurrencyEditorComponent extends IgEditorBase<IgCurrencyEditor> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
}
export declare class IgDateEditorComponent extends IgEditorBase<IgDateEditor> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
}
export declare class IgDatePickerComponent extends IgEditorBase<IgDatePicker> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
}
export declare class IgMaskEditorComponent extends IgEditorBase<IgMaskEditor> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
}
export declare class IgNumericEditorComponent extends IgEditorBase<IgNumericEditor> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
}
export declare class IgPercentEditorComponent extends IgEditorBase<IgPercentEditor> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
}
export declare class IgTextEditorComponent extends IgEditorBase<IgTextEditor> {
    model: NgModel;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel);
}
export declare class IgTreeComponent extends IgControlBase<IgTree> {
    private _dataSource;
    private _changes;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    ngOnInit(): void;
    ngDoCheck(): void;
}
export declare class IgContentControlBase<Model> extends IgControlBase<Model> {
    private childNodes;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    ngOnInit(): void;
}
export declare class IgDialogComponent extends IgContentControlBase<IgDialog> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgSplitterComponent extends IgContentControlBase<IgSplitter> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgLayoutManagerComponent extends IgContentControlBase<IgLayoutManager> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgTileManagerComponent extends IgContentControlBase<IgTileManager> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgHtmlEditorComponent extends IgControlBase<IgHtmlEditor> implements ControlValueAccessor {
    model: NgModel;
    private zone;
    protected _model: any;
    protected _zone: any;
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers, model: NgModel, zone: NgZone);
    ngOnInit(): void;
    writeValue(value: any): void;
    onChange: (_: any) => void;
    onTouched: () => void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
}
export declare class IgValidatorComponent extends IgControlBase<IgValidator> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    ngOnInit(): void;
}
export declare class IgPivotDataSelectorComponent extends IgControlBase<IgPivotDataSelector> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgPivotGridComponent extends IgControlBase<IgPivotGrid> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgDataChartComponent extends IgControlBase<IgDataChart> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgPieChartComponent extends IgControlBase<IgPieChart> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgDoughnutChartComponent extends IgControlBase<IgDoughnutChart> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgFunnelChartComponent extends IgControlBase<IgFunnelChart> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgRadialGaugeComponent extends IgControlBase<IgRadialGauge> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgZoombarComponent extends IgControlBase<IgZoombar> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgMapComponent extends IgControlBase<IgMap> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgSparklineComponent extends IgControlBase<IgSparkline> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgBulletGraphComponent extends IgControlBase<IgBulletGraph> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgLinearGaugeComponent extends IgControlBase<IgLinearGauge> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgQRCodeBarcodeComponent extends IgControlBase<IgQRCodeBarcode> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgUploadComponent extends IgControlBase<IgUpload> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgPopoverComponent extends IgControlBase<IgPopover> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    ngOnInit(): void;
}
export declare class IgNotifierComponent extends IgControlBase<any> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
    ngOnInit(): void;
}
export declare class IgRatingComponent extends IgControlBase<IgRating> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgVideoPlayerComponent extends IgControlBase<IgVideoPlayer> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgRadialMenuComponent extends IgControlBase<IgRadialMenu> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
export declare class IgSplitButtonComponent extends IgControlBase<IgSplitButton> {
    constructor(el: ElementRef, renderer: Renderer, differs: IterableDiffers);
}
